using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.IO;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Test
{
    public partial class FileSystemWatch : Form
    {
        private string watchPath = ""; // ĎfBNg̃pX

        /// <summary>
        /// ĎfBNg̃pX
        /// </summary>
        public string WatchPath
        {
            get
            {
                return this.watchPath;
            }
            set
            {
                if (Directory.Exists(value)) // fBNg݂ĂȂ
                {
                    this.dirNotFoundLabel.Visible = false;
                    this.watchPath = value;
                    this.watcher.Path = value;
                }
                else this.dirNotFoundLabel.Visible = true;
            }
        }

        public FileSystemWatch()
        {
            InitializeComponent();
            System.Console.WriteLine("start");
            this.WatchPath = @"C:\";
            this.pathText.Text = @"C:\";
        }

        /// <summary>
        /// t@C̓eύXꂽ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void watcher_Changed(object sender, System.IO.FileSystemEventArgs e)
        {
            this.logText.Text = "chenged: " + e.FullPath + "\r\n" + this.logText.Text;
        }

        /// <summary>
        /// t@CV쐬ꂽ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void watcher_Created(object sender, System.IO.FileSystemEventArgs e)
        {
            this.logText.Text = "created: " + e.FullPath + "\r\n" + this.logText.Text;

        }

        /// <summary>
        /// t@C폜ꂽ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void watcher_Deleted(object sender, System.IO.FileSystemEventArgs e)
        {
            this.logText.Text = "delated: " + e.FullPath + "\r\n" + this.logText.Text;
        }

        /// <summary>
        /// t@CύXꂽ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void watcher_Renamed(object sender, System.IO.RenamedEventArgs e)
        {
            this.logText.Text = "renamed: " + e.FullPath + "\r\n" + this.logText.Text;
        }

        
        /// <summary>
        /// Ďt@CpX̃eLXgς
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pathText_TextChanged(object sender, EventArgs e)
        {
            this.WatchPath = pathText.Text;
        }

        /// <summary>
        /// tH_Qƃ{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void folderOpenButton_Click(object sender, EventArgs e)
        {
            DialogResult dr = this.folderBrowserDialog1.ShowDialog(); // Qƃ_CAO
            if (dr == DialogResult.OK)
            {
                this.WatchPath = this.folderBrowserDialog1.SelectedPath; // ĎpXɐݒ
                this.pathText.Text = this.WatchPath;
            }
        }

        private void folderBrowserDialog1_HelpRequest(object sender, EventArgs e)
        {
            System.Console.WriteLine("hoge");
        }
    }
}